//
//  CustomController.swift
//  MassageMe
//
//  Created by Megan Leszczynski on 11/25/16.
//  Copyright © 2016 Harry+Margi. All rights reserved.
//

import UIKit
import ChameleonFramework

// protocol definitions
let custom_msg: UInt8 = 2
let high: UInt8 = 3
let medium: UInt8 = 2
let low: UInt8 = 1
let off: UInt8 = 0

// indices in message
let upper_l = 1
let upper_r = 2
let lower_l = 3
let lower_r = 4

class CustomController: UIViewController {
    
    var imageView = UIImageView(image: UIImage(named: "vestoutline2.png")!)
    let screenSize: CGRect = UIScreen.mainScreen().bounds

    var running: Bool = false
    var message: [UInt8] = [custom_msg, off, off, off, off, eot] // ul, ur, ll, lr

    let urButton = UIButton(frame: CGRect(x: 167, y: 195, width: 65, height: 65))
    let ulButton = UIButton(frame: CGRect(x: 87, y: 195, width: 65, height: 65))
    let lrButton = UIButton(frame: CGRect(x: 167, y: 285, width: 65, height: 65))
    let llButton = UIButton(frame: CGRect(x: 87, y: 285, width: 65, height: 65))

    override func viewDidLoad() {
        self.view.backgroundColor = UIColor.blackColor()
       
        imageView.frame = CGRectMake(0,135,250,300)
        imageView.center.x = self.view.center.x
        self.view.addSubview(imageView)
        
        let startButton = UIButton(frame: CGRect(x: 100, y: 475, width: 250, height: 50))
        startButton.backgroundColor = UIColor.blackColor()
        startButton.setTitleColor(HexColor("8b008B"), forState: UIControlState.Normal)
        startButton.layer.cornerRadius = 25
        startButton.layer.borderColor = HexColor("8b008B").CGColor
        startButton.layer.borderWidth = 1;
        startButton.clipsToBounds = true
        startButton.setTitle("START MASSAGE", forState: UIControlState.Normal)
        startButton.addTarget(self, action: #selector(startPushed), forControlEvents: .TouchUpInside)
        startButton.center.x = self.view.center.x
        self.view.addSubview(startButton)
        
        // upper right
        urButton.backgroundColor = UIColor.blackColor()
        urButton.setTitleColor(HexColor("8b008B"), forState: UIControlState.Normal)
        urButton.layer.cornerRadius = 10
        urButton.layer.borderColor = HexColor("8b008B").CGColor
        urButton.layer.borderWidth = 1;
        urButton.clipsToBounds = true
        urButton.addTarget(self, action: #selector(urPushed), forControlEvents: .TouchUpInside)
        self.view.addSubview(urButton)
        
        // upper left
        ulButton.backgroundColor = UIColor.blackColor()
        ulButton.setTitleColor(HexColor("8b008B"), forState: UIControlState.Normal)
        ulButton.layer.cornerRadius = 10
        ulButton.layer.borderColor = HexColor("8b008B").CGColor
        ulButton.layer.borderWidth = 1;
        ulButton.clipsToBounds = true
        ulButton.addTarget(self, action: #selector(ulPushed), forControlEvents: .TouchUpInside)
        self.view.addSubview(ulButton)
        
        // lower right
        lrButton.backgroundColor = UIColor.blackColor()
        lrButton.setTitleColor(HexColor("8b008B"), forState: UIControlState.Normal)
        lrButton.layer.cornerRadius = 10
        lrButton.layer.borderColor = HexColor("8b008B").CGColor
        lrButton.layer.borderWidth = 1;
        lrButton.clipsToBounds = true
        lrButton.addTarget(self, action: #selector(lrPushed), forControlEvents: .TouchUpInside)
        self.view.addSubview(lrButton)
        
        // lower left
        llButton.backgroundColor = UIColor.blackColor()
        llButton.setTitleColor(HexColor("8b008B"), forState: UIControlState.Normal)
        llButton.layer.cornerRadius = 10
        llButton.layer.borderColor = HexColor("8b008B").CGColor
        llButton.layer.borderWidth = 1;
        llButton.clipsToBounds = true
        llButton.addTarget(self, action: #selector(llPushed), forControlEvents: .TouchUpInside)
        self.view.addSubview(llButton)
        
        let label = UILabel(frame: CGRect(x: 0, y: 65, width: 200, height: 50))
        label.center.x = self.view.center.x
        label.text = "SET STRENGTH"
        label.textAlignment = .Center
        label.font = UIFont(name: "ArialUnicodeMS", size: 20)
        label.textColor = .whiteColor()
        self.view.addSubview(label)
    }
    
    func startPushed(sender: UIButton) {
        if serial.isReady && !running {
            print(message)
            serial.sendBytesToDevice(message)
            running = true
            // change to stop massage option
            sender.backgroundColor = HexColor("8b008B")
            sender.setTitleColor(.whiteColor(), forState: .Normal)
            sender.setTitle("STOP MASSAGE", forState: .Normal)
        }
        else if (running){ // stop
            running = false
            sender.setTitle("START MASSAGE", forState: .Normal)
            sender.backgroundColor = UIColor.blackColor()
            serial.sendBytesToDevice([stop_msg, eot])
            print([stop_msg, eot])
            sender.setTitleColor(HexColor("8b008B"), forState: UIControlState.Normal)
            // reset other buttons
        }
    }

    func urPushed(sender: UIButton) {
        message[upper_r] = (message[upper_r] + 1) % 4
        // off
        if message[upper_r] == 0 {
            sender.backgroundColor = UIColor.blackColor()
            sender.layer.borderColor = HexColor("8b008B").CGColor
        }
        else if message[upper_r] == 1 { // low
            sender.backgroundColor = HexColor("cc79dc")
            sender.layer.borderColor = HexColor("cc79dc").CGColor
        }
        else if message[upper_r] == 2 { // med
            sender.backgroundColor = HexColor("8b008b")
            sender.layer.borderColor = HexColor("8b008B").CGColor

        }
        else { // high
            sender.backgroundColor = HexColor("4f0d61")
            sender.layer.borderColor = HexColor("4f0d61").CGColor
        }
        if (running && serial.isReady){
            print(message)
            serial.sendBytesToDevice(message)
        }
    }
    
    func ulPushed(sender: UIButton) {
        message[upper_l] = (message[upper_l] + 1) % 4
        // off
        if message[upper_l] == 0 {
            sender.backgroundColor = UIColor.blackColor()
            sender.layer.borderColor = HexColor("8b008B").CGColor
        }
        else if message[upper_l] == 1 { // low
            sender.backgroundColor = HexColor("cc79dc")
            sender.layer.borderColor = HexColor("cc79dc").CGColor
        }
        else if message[upper_l] == 2 { // med
            sender.backgroundColor = HexColor("8b008b")
            sender.layer.borderColor = HexColor("8b008B").CGColor
            
        }
        else { // high
            sender.backgroundColor = HexColor("4f0d61")
            sender.layer.borderColor = HexColor("4f0d61").CGColor
        }
        if (running && serial.isReady){
            print(message)
            serial.sendBytesToDevice(message)
        }
    }
    
    func llPushed(sender: UIButton) {
        message[lower_l] = (message[lower_l] + 1) % 4
        // off
        if message[lower_l] == 0 {
            sender.backgroundColor = UIColor.blackColor()
            sender.layer.borderColor = HexColor("8b008B").CGColor
        }
        else if message[lower_l] == 1 { // low
            sender.backgroundColor = HexColor("cc79dc")
            sender.layer.borderColor = HexColor("cc79dc").CGColor
        }
        else if message[lower_l] == 2 { // med
            sender.backgroundColor = HexColor("8b008b")
            sender.layer.borderColor = HexColor("8b008B").CGColor
            
        }
        else { // high
            sender.backgroundColor = HexColor("4f0d61")
            sender.layer.borderColor = HexColor("4f0d61").CGColor
        }
        if (running && serial.isReady){
            print(message)
            serial.sendBytesToDevice(message)
        }
    }
    
    func lrPushed(sender: UIButton) {
        message[lower_r] = (message[lower_r] + 1) % 4
        // off
        if message[lower_r] == 0 {
            sender.backgroundColor = UIColor.blackColor()
            sender.layer.borderColor = HexColor("8b008B").CGColor
        }
        else if message[lower_r] == 1 { // low
            sender.backgroundColor = HexColor("cc79dc")
            sender.layer.borderColor = HexColor("cc79dc").CGColor
        }
        else if message[lower_r] == 2 { // med
            sender.backgroundColor = HexColor("8b008b")
            sender.layer.borderColor = HexColor("8b008B").CGColor
            
        }
        else { // high
            sender.backgroundColor = HexColor("4f0d61")
            sender.layer.borderColor = HexColor("4f0d61").CGColor
        }
        if (running && serial.isReady){
            print(message)
            serial.sendBytesToDevice(message)
        }
    }
}
